﻿class Main extends MovieClip
{
	var mouseTrace :graphXYTrace;
	
	var linePoly1 :graphPoly;

	var nXDiv :Number;//miejsce rozdzielenia garafów

	var nInfoWdth :Number = 200;//szer okna informacyjnego
	var boxInfo :grInfo;
	
	//var tfCaption:TextField;

	var sW:Number = null; 	// Stage width
	var sH:Number = null;	// Stage height 	

	private function getLev0ParNum ( lev0Par, maxNum :Number, defNum :Number) :Number
	{
		var n0 = parseInt(lev0Par);
		if (( n0 != undefined ) 
			&& (!( isNaN(n0) ))
			&& ( n0 >= 0 ) 
			&& ( n0 <= maxNum ) ) 
				return n0;
		else return defNum;
	}
	

	public function Main ( target )
	{
		// Link movie clips to classes
		//Object.registerClass ( "spheres", Particle );		
		
		// Assimilate the target
		target.__proto__ = this.__proto__;
		target.__constructor__ = Main;
		this = target;		

		//trace("Main initialized: " + this , Log.INFO);

		// Store stage dimensions for easy look-up
		sW = Stage.width - 1;
		sH = Stage.height - 1;
				//trace('sW = '+sW+'  sH = '+sH);
		
		graph0.lang_Id = getLev0ParNum( _level0.Language, graph0.LANG_NUM-1, graph0.lang_Id );
 
		var my_fmt :TextFormat = new TextFormat();
/*	
		my_fmt.size = 8;
		my_fmt.font = "font1";
/*	*/	
		my_fmt.size = 15-3;
		my_fmt.font = "_sans";
/* */
/*
		var captionText:String  = 
		( this.lngId == 1 ?
		"Przesuwaj kursor myszy nad lewą płaszczyzną, kliknij. "
		+"Klinij na prawej płaszczyźnie -> nast. f(t). "
		+"Edytuj liczby w ramce."
		:
		"Move mouse over left plane; click. Next f(t) -> click right plane. "
		+"Edit numbers in border."
		);

		var captionTextExtent:Object = my_fmt.getTextExtent ( 
			captionText );
		var captionHeight:Number = captionTextExtent.textFieldHeight;
		
		createTextField( "tfCaption", -77, 1, 1, sW, captionHeight );
		my_fmt.color = 0x0000cc;
		//tfCaption.embedFonts = true;
		tfCaption.setNewTextFormat(my_fmt);
		
		tfCaption.text = captionText;
*/
		var captionHeight:Number = 0;
		my_fmt.size = 15;
		my_fmt.color = 0xFF00FF;
		
		sW -= this.nInfoWdth;

		boxInfo = new grInfo(target, -230);
		boxInfo.nHeight = sH - captionHeight -2;
		boxInfo.nWidth = this.nInfoWdth;
		boxInfo.nLeft = sW;
		boxInfo.nTop =  2;
		boxInfo.drawBackground();
				
		this.nXDiv = sW/3;

		mouseTrace = new graphXYTrace(target, -10);
		mouseTrace.nHeight = sH - captionHeight -2;
		mouseTrace.nWidth = nXDiv -2;
		mouseTrace.nLeft = 2;
		mouseTrace.nTop = captionHeight + 2;
		graphXYTrace.my_fmt = my_fmt;
		mouseTrace.drawBackground();
		
		linePoly1 = new graphPoly(target, -50);
		linePoly1.nHeight = sH - captionHeight -2;
		linePoly1.nWidth = (sW - nXDiv) - 4;
		linePoly1.nLeft = nXDiv + 2;
		linePoly1.nTop = captionHeight +2;
		linePoly1.nDivX = 10;
		graphPoly.my_fmt = my_fmt;

		//<param name="FlashVars" value="GraphTypeNr=1&xxxxxxx=2" />
		graphPoly.grphType = getLev0ParNum( _level0.GraphTypeNr, 
			graphPoly.GRPH_TYPE_NUM-1, graphPoly.grphType );
		
		graphPoly.alphaInf = getLev0ParNum( _level0.AlphaInfo, 
			100, graphPoly.alphaInf );
		
		linePoly1.drawBackground();
		boxInfo.redraw(graphPoly.grphType);

		//trace(mouseTrace.nY_max, Log.INFO);
	}

	private function MouseAction (x :Number, y :Number, shot :Boolean):Boolean {
		if
			( mouseTrace.redraw(x, y, shot) )
		{
			linePoly1.redraw(mouseTrace.nX_val, mouseTrace.nY_val, shot);
			updateAfterEvent();
			return(true);
		}
		else return(false);
	}//function MouseAction 

	private function Chng_grphType (x :Number, y :Number) :Boolean {
			//kliknięcie na Poly zmienia typ wykresu
		if ( graph0.insideBox(x, y, 
			linePoly1.nLeft, linePoly1.nTop, linePoly1.nWidth, 
			linePoly1.nHeight-30 /* żeby nie zasłonić dolnych liczb */ )) {
			if ( x < linePoly1.nLeft + linePoly1.nWidth/4 )
				--graphPoly.grphType;
			else if ( x > linePoly1.nLeft + linePoly1.nWidth*3/4 )
				++graphPoly.grphType;
			linePoly1.refreshHeader();
	
			linePoly1.redraw(NaN, NaN, /* shot */ true);//mazanie
			linePoly1.clrPolyLim();
			
			boxInfo.redraw(graphPoly.grphType);
			updateAfterEvent();
			return true;
		}
		else return false;
	}
	
	function onMouseDown () {
		if (MouseAction( _xmouse, _ymouse, true )) ;
		else Chng_grphType( _xmouse, _ymouse ); 
	}//function onMouseDown
	
	function onMouseMove () {
		if
			MouseAction( _xmouse, _ymouse, false )
			;/*
				if ( tfCaption.textColor < 0xCf0000 ) 
					tfCaption.textColor += 0x020200;
			*/
	}
	
	static function main ()
	{
		// Create an Main instance and 
		// have is assimilate _root.
		var test:Main = new Main( _root );
	}
}	
	
	
